--**********************************
-- Desc: 常量定义
-- FILE: Constant.lua
-- Author: zhouhaifeng
-- Date: 2014-03-19 16:01:34
--**********************************

--********************
-- 全局常量
--********************
DISTANCE_FACTOR = 1.5  --路程缩放

g_IsPause = false
g_IsInGame = false

--*********************
-- 引导常量
--*********************

kGUIDE_EQUIP = 1
kGUIDE_CAR   = 2
kGUIDE_EQUIP_NEXT = 3

kGUIDE_LEVEL = 4
kGUIDE_LEVEL_NEXT = 5

kGUIDE_MOVE  = 6
kGUIDE_FIRE  = 7
kGUIDE_SPEED = 8

kGUIDE_TIP   = 9
kGUIDE_PAUSE = 10

kGUIDE_TASK   = 11
kGUIDE_TITLE  = 12

kGUIDE_RESUME   = 13
kGUIDE_BULLETS  = 14
kGUIDE_BULLETS_NEXT  = 15

kGUIDE_SPEEDUP  = 16
kGUIDE_SPEED_NEXT  = 17


--*********************
-- 游戏状态
--*********************
GAME_STATE = {
	PRESTART = 0,  --准备开始
    START = 1,	   --进行中
    PAUSE = 3,	   --暂停
    WIN = 4,	   --胜利
    FAILED = 5,	   --失败
}

--*********************
-- 道具类型
--*********************
--坐骑
kItemTypeCars = 1 	
--武器
kItemTypeWeapon = 2
--衣服
kItemTypeClothes = 3
--道具
kItemTypeProps = 4
--套装
kItemTypePackage = 6
--金币
kItemTypeGold = 9

kItemTypeTemp = 10

--*********************
--	枪支类型
--*********************
kWeaponTypeHandGun = 1

kWeaponTypeRifle = 2

kWeaponTypeShotGun = 3

kWeaponTypeRPG = 4

--*********************
--游戏内物体类型
--*********************
BLOCK = {
			BLOCK_TYPE_CAR = 1,			--车
			BLOCK_TYPE_HILL = 2,		--斜坡
			BLOCK_TYPE_SIGN = 3 		--指示牌
		}
		
ENEMY = {
			ENEMY_TYPE_ZOBIME_1 = 1,		--有攻击力的僵尸1
			ENEMY_TYPE_ZOBIME_2 = 2,		--有攻击力的僵尸2	
		}

MONSTER = {
			MONSTER_TYPE_MONSTER_1 = 1,		--人肉靶子僵尸1
			MONSTER_TYPE_MONSTER_2 = 2,		--人肉靶子僵尸2	
		}		


--[[*************************
		子弹的属性
--***************************]]

BULLET_PROPS = {
		[kWeaponTypeHandGun] = {	--手枪
			image = "animations/bullet_1.png",
			texRect = CCRectMake(0, 0, 60, 8),
		},		
		[kWeaponTypeRifle] = { 		--冲锋枪
			image = "animations/bullet_2.png",
			texRect = CCRectMake(0, 0, 40, 10),
		},
		[kItemTypeClothes] = {	--散弹枪
			image = "animations/bullet_1.png",
			texRect = CCRectMake(0, 0, 32, 6),
		},		
		[kWeaponTypeRPG] = {		--榴弹枪
			image = "animations/bullet_1.png",
			texRect = CCRectMake(0, 0, 32, 6),
			hitRound = 400,
		},	
}

--[[*************************
		障碍物的属性
--***************************]]

BLOCK_PROPS = {
	[BLOCK.BLOCK_TYPE_CAR] = {
		name = "车辆1",
		image = R.s_car_1,
		hitrect = CCSize(6,3),
		blockType = 2,
		pos = ccp(math.random(30,60),math.random(0,8)),
		eventRect = CCRectMake(0,0,96,48),
		texRect = CCRectMake(0, 0, 192, 96),
		enabled = true
	},
	[BLOCK.BLOCK_TYPE_HILL] = {
		name = "斜坡",
		blockType = 1,
		hitrect = CCSize(3,1.5),
		eventRect = CCRectMake(0,16,32,32),
		pos = ccp(math.random(30,60),math.random(0,8)),
		texRect = CCRectMake(0, 0, 128, 64),
		enabled = true
	},
	[BLOCK.BLOCK_TYPE_SIGN] = {
		name = "警示牌",
		image = R.s_car_1,
		hitrect = CCSize(6,3),
		blockType = 2,
		pos = ccp(math.random(30,60),math.random(0,8)),
		eventRect = CCRectMake(0,0,32,32),
		texRect = CCRectMake(0, 0, 32, 32),
		enabled = true
	}
}

--[[*************************
		敌人的属性
--***************************]]
ENEMY_PROPS = {
	[ENEMY.ENEMY_TYPE_ZOBIME_1] = {
		name = "追赶的僵尸1",
		hitrect = CCSize(1,1),
		eventRect = CCRectMake(0,0,12,12),
		--pos = ccp(math.random(-3,1),math.random(0,8)),
		enabled = true
	},
	[ENEMY.ENEMY_TYPE_ZOBIME_2] = {
		name = "追赶的僵尸2",
		--hitrect = CCSize(1,1),
		--eventRect = CCRectMake(0,0,12,12),
		--pos = ccp(math.random(-3,1),math.random(0,8)),
		enabled = true
	}
}

--[[*************************
		撞击的僵尸
--***************************]]

MONSTER_PROPS = {
	[MONSTER.MONSTER_TYPE_MONSTER_1] = {
		name = "僵尸1",
		hitrect = CCSize(1,1),
		eventRect = CCRectMake(0,0,12,12),
		--pos = ccp(math.random(30,60),math.random(0,8)),
		enabled = true
	},
	[MONSTER.MONSTER_TYPE_MONSTER_2] = {
		name = "僵尸2",
		hitrect = CCSize(1,1),
		eventRect = CCRectMake(0,0,12,12),
		--pos = ccp(math.random(30,60),math.random(0,8)),
		enabled = true
	}
}

--[[*************************
		军衔等级
--***************************]]

TITLE_DATA = {
	[1] = "列兵1级",
	[2] = "上等兵2级",
	[3] = "下士3级",
	[4] = "中士4级",
	[5] = "上士5级",
	[6] = "军士长6级",
	[7] = "少尉7级",
	[8] = "中尉8级",
	[9] = "上尉9级",
	[10] = "大尉10级",
	[11] = "少校11级",
	[12] = "中校12级",
	[13] = "上校13级",
	[14] = "大校14级",
	[15] = "准将15级",
	[16] = "少将16级",
	[17] = "中将17级",
	[18] = "上将18级",
	[19] = "特技上将19级",
	[20] = "元首20级",
}





