--	
-- Desc: 玩家记录进度条
-- File: PlayerReordBar.lua
-- Author: zhouhaifeng
-- Date: 2014-03-25 14:58:22
--
local PlayerRecordBar = class("AchievementCell", function()
	return ccs.panel({})
end)


function PlayerRecordBar:ctor(barName)
	self.barName = barName
	self:setAnchorPoint(ccp(0,0))

	if barName == "distance" then
		self.desc = ""
		self.barImage = "ui/score/score_progress.png"
		self.suffix = ""
	elseif barName == "kill" then
		self.desc = ""
		self.barImage = "ui/score/score_progress.png"
		self.suffix = ""
	elseif barName == "combo" then
		self.desc = ""
		self.barImage = "ui/score/score_progress.png"
		self.suffix = ""
	elseif barName == "speed" then
		self.desc = ""
		self.barImage = "ui/score/score_progress.png"
		self.suffix = ""
	end


	self.line = ccs.image({	
		image = "ui/score/score_progress_bg.png",
	    x = 0,
	    y = 20,
	})
	self.line:setAnchorPoint(ccp(0.5,0))
	self:addChild(self.line)

	self.loadBar = ccs.loadingbar({
		image  = self.barImage,
		percent = 0,
		x = 0,
		y = 30,
	})
	self.loadBar:setAnchorPoint(ccp(0,0))
	self:addChild(self.loadBar)

	self.descLabel = ccs.labelAtlas({
	    text = "0",
        start = '0',
        image = "ui/score/number_bar_score.png",
        w = 14	,
        h = 22,
	    align = ui.TEXT_ALIGN_RIGHT, 
	    x = 300,
	    y = 20,
	})
	self.descLabel:setAnchorPoint(ccp(1,0))
	self:addChild(self.descLabel)
end

function PlayerRecordBar:setItemInfo(params)
	time = 1.5
	if params then
		-- self.loadBar:setPercent(params.num/params.max * 100)
		-- self.descLabel:setText(self.desc .. params.num .. self.suffix)
		local percent = (params.num/params.max) 
		if percent > 1 then
			percent = 1
		end

		EffectHelper.RollNumEffect(self.loadBar , time - 0.5 ,0, percent * 100, self.desc  , self.suffix) 
    	EffectHelper.RollNumEffect(self.descLabel, time ,0, params.num, self.desc ,self.suffix) 
	end
	
end


 return PlayerRecordBar