--
-- Author: zhouhaifeng
-- Date: 2014-03-27 10:25:45
--

local TaskInfoCell = class("TaskInfoCell",function()
	return display.newNode()
end)


function TaskInfoCell:ctor( ... )
	
end


function TaskInfoCell:setup(params)
	assert(type(params) == "table",
           "[utils.ui] TaskInfoCell.new() invalid params")
    self.max    = params.max or 3
    self.cur    = params.cur or 0
    self.on     = params.on
    assert(self.on and type(self.on) == "string", "[ui.TaskInfoCell] invalid params.on")
    self.off    = params.off
    assert(self.off and type(self.off) == "string", "[ui.TaskInfoCell] invalid params.off")
    self.half   = params.half 

    self.offset = params.offset or 8  
    local x, y      = params.x, params.y

    self.rates = {}
    self.labels = {}
    local starX = 30
    local starY = 0
    for i = 1 , params.max do
        local star = display.newSprite(params.off, starX, starY)
        local label = ui.newTTFLabel({
	        text = "",
	      	size = 18,
            dimensions = CCSize(200,28),
	      	align = ui.TEXT_ALIGN_LEFT,  
	        x = starX + 140,
	        y = starY,
   		})

         self.labels[i] = label
    	 self.rates[i] = star
    	 self:addChild(star)
    	 self:addChild(label)

    	 starY = starY - star:getContentSize().height - self.offset
    end
    
    if type(x) == "number" and type(y) == "number" then
        self:setPosition(x, y)
    end

    self:setContentSize(CCSizeMake(starX, starY))

	return self
end

--[[
    设置任务信息
]]
function TaskInfoCell:setTaskInfo(tasks)

    local i = 1
    for k,v in pairs(tasks) do
         if i>3 then
             return 
         end

         local label = self.labels[i] 
         local star = self.rates[i]  
         local contentRect = star:getDisplayFrame():getRect()  

         local data = TaskSystem:getTaskInfoById(v.taskId)
         label:setString(data.name)    

         -- CCLuaLog("data:"..data.name)
         
         if v.isFinished then   
            star:setDisplayFrame(CCSpriteFrame:create(self.on,contentRect))
         else
            star:setDisplayFrame(CCSpriteFrame:create(self.off,contentRect))
         end

         i = i + 1
    end

end


function TaskInfoCell:onEner()
	
end

function TaskInfoCell:onExit()
	
end


return TaskInfoCell