--*********************************************
-- Desc: 激活弹窗
-- File: ActivateLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-10-13 14:23:38
--*********************************************

local ActivateLayer = class("ActivateLayer",function()
	return display.newColorLayer(ccc4(0,0,0,180))
end)

--[[
	初始化
	确认购买界面
]]
function ActivateLayer:ctor()
    self.layer = UIModalLayer:create()
    self:addChild(self.layer);

    self:setupUI()
end

function ActivateLayer:setupUI()
	  self.callback = callback

	 self.panel = ccs.image({
	 	 image = "ui/buy/ui_activate_bg.png",
	 	 x = display.cx, 
	 	 y = display.cy
	 })
 	 self.layer:addWidget(self.panel)
   

	self.closeButton = ccs.button({
        normal  = "ui/buy/btn_activate_close.png",
        pressed = "ui/buy/btn_activate_close.png",
        x = 280,
        y = 140,
        listener = {[ccs.TouchEventType.ended] = function() 
            audio.playEffect(R.SOUND_BUTTON)
            self:dismissSelf()
            MyApp:goToForeverMode()
         end},
    })


	self.activateButton = ccs.button({
        normal  = "ui/buy/btn_activate_1.png",
        pressed = "ui/buy/btn_activate_2.png",
        x = 10,
        y = -125,
        listener = {[ccs.TouchEventType.ended] = function() 
            audio.playEffect(R.SOUND_BUTTON)
        	PaySystem:pay(4006, false, function(result)
            	if result == PAY.PAY_STATE_SUCCESS then
            		--add 
            		EquipSystem:setPropNum(4003,EquipSystem:getPropNum(4003)+2)
            		
            		PaySystem:bonus(3888, false)
            		
            		EquipSystem:buyItem(2002,false)

            		LevelSystem:setIsActivate()
           			EquipSystem:save()
            		PaySystem:save()

            		self:dismissSelf(anim)
		            if self.callback then
		                self.callback(result)
		            end
            	end
            end)     
         end},
    })

    self.panel:addChild(self.closeButton)
    self.panel:addChild(self.activateButton)

    EffectHelper.WidgetBobbleInEffect(self.panel,function()
    	display.pause()
    end)

    g_IsInGame = true

end

function ActivateLayer:dismissSelf( ... )
	display.resume()
    EffectHelper.WidgetBobbleOutEffect(self.panel,function()
         self:removeFromParentAndCleanup(true)

         local controlLayer = Global:get("controlLayer")
         controlLayer:updatePropNumber()
    end)
end

function ActivateLayer:onExit()
	  g_IsInGame = false
end

return ActivateLayer