--*******************************************
-- Desc: 购买弹出窗口
-- File: BuyConfirmLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-03-24 13:36:33
--*******************************************

local GameItems = import("app.datas.GameItems")
local NoMoneyConfirmLayer = import("app.layers.NoMoneyConfirmLayer")
local PackageLayer = import("app.layers.PackageLayer")
local BuyConfirmLayer = class("BuyConfirmLayer",function()
	return display.newColorLayer(ccc4(0,0,0,180))
end)

--[[
	初始化
	确认购买界面
]]
function BuyConfirmLayer:ctor()
    self.layer = UIModalLayer:create()
    self:addChild(self.layer);
end

--[[
  返回推送项
]]
function BuyConfirmLayer:getPushItem()
    if GameSystem._record.lastGameInfo then 
        if GameSystem._record.preGameInfo then
            if GameSystem._record.lastGameInfo.distance < GameSystem._record.preGameInfo.distance then
                  local currentMap = LevelSystem:getCurrentPlayMap()
                  local rand = math.random(0,100)

                  if currentMap == 1 then
                      if rand < 40 then
                          return 1002
                      elseif rand < 60 then
                          return 2002
                      elseif rand < 75 then 
                          return 2003
                      end
                  elseif currentMap == 2 then
                      if rand < 30 then
                          return 1003
                      elseif rand < 45 then
                          return 2004
                      elseif rand < 55 then
                          return 2005
                      end
                  elseif currentMap == 3 then
                      if rand < 20 then
                          return 1004
                      elseif rand < 30 then
                          return 2006
                      elseif rand < 35 then
                          return 2007
                      end
                  elseif currentMap == 4 then
                      if rand < 10 then
                          return 1005
                      elseif rand < 13 then
                          return 2008
                      elseif rand < 15 then
                          return 2009
                      end
                  end
            end
        end
        return nil
    end
    return nil
end 

function BuyConfirmLayer:setItemIdToBuy(itemId,iconImage,callback)
  self.callback = callback

  local prop = GameItems[itemId]
  self.prop = prop

	 self.panel = ccs.image({
	 	 image = "ui/buy/ui_buy_bg.png",
	 	 x = display.cx, 
	 	 y = display.cy
	 })
	 
 	 self.layer:addWidget(self.panel)
    
    
   --说明:
	  self.descLabel = ccs.label({
        text = prop.desc,
        fontSize = 16,
        x = 95,
        y = 10,
    })
    self.descLabel:setTextAreaSize(CCSizeMake(240,100))


    if prop.levelLimit then
       self.levelLimit = ccs.label({
          text = "需要:" .. TITLE_DATA[prop.levelLimit],
          fontSize = 16,
          x = -100, 
          y = -60
      })
      self.levelLimit:setTextAreaSize(CCSizeMake(150,40))
      self.panel:addChild(self.levelLimit)
    end

    local proptext = ""
    if self.prop.itemType == kItemTypeCars then
        proptext = "生命值+" .. self.prop.hp*100 .. "  最大速度:" .. self.prop.maxSpeed
    elseif self.prop.itemType == kItemTypeWeapon then
        proptext = "伤害:" .. self.prop.minHurt .. "-" .. self.prop.maxHurt .. "  弹夹容量:" .. self.prop.bullet
    elseif self.prop.itemType == kItemTypeClothes then
        proptext = "生命值+" .. self.prop.hp*100 .. "  伤害提升:" .. (self.prop.hurt - 1) * 100 .. "%"
     elseif self.prop.itemType == kItemTypeGold then
        proptext = "金币:" .. self.prop.gold
    end
    --属性
    self.propLabel = ccs.label({
        text = proptext,
        fontSize = 16,
        color = ccc3(96, 240, 90),
        x = 95,
        y = -40,
    })
    self.propLabel:setTextAreaSize(CCSizeMake(240,100))

    local price = prop.price
    if prop.buyType == 1 then
        price = price .. "元"
    elseif  prop.buyType == 0 then
        price = price .. ""
    else
        price = ""
    end

    self.itemIcon = ccs.image({
         image = iconImage,
         x = -200, 
         y = 25
     })
     self.itemIcon:setAnchorPoint(ccp(0,0.5))

	self.closeButton = ccs.button({
        normal  = "ui/buy/btn_close_n.png",
        pressed = "ui/buy/btn_close_h.png",
        x = -140,
        y = -100,
        listener = {[ccs.TouchEventType.ended] = function() 
            audio.playEffect(R.SOUND_BUTTON)
            self:dismissSelf()
            if self.callback then
                self.callback(0)
            end
         end},
    })


    --购买
    self.buyButton = ccs.button({
        normal  = "ui/buy/btn_buy_n.png",
        pressed = "ui/buy/btn_buy_h.png",
        size = CCSize(150,45),
        scale9 = true,
        text = price,
        x = 130,
        y = -100,
        listener = {[ccs.TouchEventType.began] = function() 
              audio.playEffect(R.SOUND_BUTTON)

              --被限制了
              if EquipSystem:checkIsInLimit(self.prop.itemId) then
                  if LevelSystem:getCurrentLevel() < 7 then
                      local packageLayer = PackageLayer:new()
                      packageLayer:setupTitleUI(callback)
                      self:addChild(packageLayer)
                  else
                      EffectHelper.floatMessage("您的军衔等级不够")
                  end

                  return
              end

              --使用金币购买
              if self.prop.buyType == 0 then
                --金币支付
                  if PaySystem:buy(self.prop.itemId,true,function( ... ) self:payCallbackFunction( ... ) end) then

                  else 
                        local noMoneyLayer = NoMoneyConfirmLayer:new()
                        self:addChild(noMoneyLayer)
                  end

              --使用人民币购买
              elseif self.prop.buyType == 1 then 
              
                 if self.prop.itemType == kItemTypeGold then
                     --充值金币
                      PaySystem:pay(self.prop.itemId,true,function( ... ) self:rechargeCallbackFunction( ... ) end)
                 else
                      --购买装备
                      local flag = EquipSystem:checkIsExist(self.prop.itemId)
                      if not flag then
                      --购买   
                          PaySystem:pay(self.prop.itemId, true, function( ... ) self:payCallbackFunction(...) end)
                      else
                      --已经存在
                          EquipSystem:equipItem(self.prop.itemId)
                          EffectHelper.floatMessage("您已经购买" .. self.prop.name)
                          self:dismissSelf()
                          audio.playEffect(R.SOUND_USE_ITEM,false)
                      end
                 end
             end
      end},
    })

    self.goldIcon = ccs.image({
         image = "ui/buy/ui_gold_icon.png",
         x = -45, 
         y = 0
     })
    self.buyButton:addChild(self.goldIcon)

    if prop.buyType == 1 then
        self.goldIcon:setVisible(false)
    end
    
    self.buyButton:setTitleFontSize(20)

    self.panel:addChild(self.propLabel)
    self.panel:addChild(self.descLabel)
    self.panel:addChild(self.itemIcon)
    self.panel:addChild(self.itemLabel)
    self.panel:addChild(self.priceLabel)
    self.panel:addChild(self.closeButton)
    self.panel:addChild(self.buyButton)

    EffectHelper.WidgetBobbleInEffect(self.panel,nil)
end


--[[
  设置推送的物品内容
]]
function BuyConfirmLayer:setItemIdToPush(itemId,iconImage,callback)
   self.callback = callback

  local prop = GameItems[itemId]
  self.prop = prop

   self.panel = ccs.image({
     image = "ui/buy/ui_buy_bg.png",
     x = display.cx, 
     y = display.cy
   })
   self.layer:addWidget(self.panel)

    --说明:
    self.descLabel = ccs.label({
        text = prop.desc,
        fontSize = 16,
        x = 95,
        y = 10,
    })
    self.descLabel:setTextAreaSize(CCSizeMake(240,100))

    local proptext = ""
    if self.prop.itemType == kItemTypeCars then
        proptext = "生命值+" .. self.prop.hp*100 .. "  最大速度:" .. self.prop.maxSpeed
    elseif self.prop.itemType == kItemTypeWeapon then
        proptext = "伤害:" .. self.prop.minHurt .. "-" .. self.prop.maxHurt .. "  弹夹容量:" .. self.prop.bullet
    elseif self.prop.itemType == kItemTypeClothes then
        proptext = "生命值+" .. self.prop.hp*100 .. "  伤害提升:" .. (self.prop.hurt - 1) * 100 .. "%"
     elseif self.prop.itemType == kItemTypeGold then
        proptext = "金币:" .. self.prop.gold
    end


    --属性
    self.propLabel = ccs.label({
        text = proptext,
        fontSize = 16,
        color = ccc3(96, 240, 90),
        x = 95,
        y = -40,
    })
    self.propLabel:setTextAreaSize(CCSizeMake(240,100))

    local oldprice = prop.price 
    local price = prop.price 

    if prop.buyType == 1 then
        price = price .. "元"
        oldprice = oldprice .. "元"
    elseif  prop.buyType == 0 then
        price = price .. ""
        oldprice = oldprice .. ""
    else
        price = ""
        oldprice = ""
    end

    -- self.oldPrice = ccs.label({
    --     text = oldprice,
    --     fontSize = 20,
    --     x = 130,
    --     y = -55
    -- })

    -- self.deleteLine = ccs.image({
    --      image = "ui/buy/ui_delete_line.png",
    --      x = 130, 
    --      y = -55
    --  })

     self.itemIcon = ccs.image({
         image = iconImage,
         x = -200, 
         y = 25
     })
     self.itemIcon:setAnchorPoint(ccp(0,0.5))

  

    self.closeButton = ccs.button({
        normal  = "ui/buy/btn_close_n.png",
        pressed = "ui/buy/btn_close_h.png",
        x = -140,
        y = -100,
        listener = {[ccs.TouchEventType.ended] = function() 
            audio.playEffect(R.SOUND_BUTTON)
            self:dismissSelf()
            if self.callback then
                self.callback(0)
            end
         end},
    })

    --购买
    self.buyButton = ccs.button({
        normal  = "ui/buy/btn_buy_n.png",
        pressed = "ui/buy/btn_buy_h.png",
        size = CCSize(150,45),
        scale9 = true,
        text = price,
        x = 130,
        y = -100,
        listener = {[ccs.TouchEventType.began] = function() 
              audio.playEffect(R.SOUND_BUTTON)

              --被限制了
              if EquipSystem:checkIsInLimit(self.prop.itemId) then
                  if LevelSystem:getCurrentLevel() < 7 then
                      local packageLayer = PackageLayer:new()
                      packageLayer:setupTitleUI(callback)
                      self:addChild(packageLayer)
                  else
                      EffectHelper.floatMessage("您的军衔等级不够")
                  end
                  return
              end

              --使用金币购买
              if self.prop.buyType == 0 then
                --金币支付
                  if PaySystem:buy(self.prop.itemId,true,function( ... ) self:payCallbackFunction( ... ) end,prop.price) then

                  else 
                    local noMoneyLayer = NoMoneyConfirmLayer:new()
                    self:addChild(noMoneyLayer)
                  end                  
              --使用人民币购买
              elseif self.prop.buyType == 1 then 
                    --购买装备
                    local flag = EquipSystem:checkIsExist(self.prop.itemId)
                    if not flag then
                    --购买   
                        PaySystem:pay(self.prop.itemId, true, function( ... ) self:payCallbackFunction(...) end,prop.price)
                    else
                    --已经存在
                        EquipSystem:equipItem(self.prop.itemId)
                        EffectHelper.floatMessage("您已经购买" .. self.prop.name)
                        self:dismissSelf()
                        audio.playEffect(R.SOUND_USE_ITEM,false)
                    end
             end
      end},
    })

    self.buyButton:setTitleFontSize(20)

    -- self.goldIcon1 = ccs.image({
    --      image = "ui/buy/ui_gold_icon.png",
    --      x = 85,
    --      y = -55
    --  })
    -- self.panel:addChild(self.goldIcon1)

    self.goldIcon2 = ccs.image({
         image = "ui/buy/ui_gold_icon.png",
         x = -45, 
         y = 0
     })
    self.buyButton:addChild(self.goldIcon2)

    if prop.buyType == 1 then
        -- self.goldIcon1:setVisible(false)
        self.goldIcon2:setVisible(false)
    end


    self.panel:addChild(self.oldPrice)
    self.panel:addChild(self.deleteLine)
    self.panel:addChild(self.propLabel)
    self.panel:addChild(self.descLabel)
    self.panel:addChild(self.itemIcon)
    self.panel:addChild(self.itemLabel)
    self.panel:addChild(self.priceLabel)
    self.panel:addChild(self.closeButton)
    self.panel:addChild(self.buyButton)

    EffectHelper.WidgetBobbleInEffect(self.panel,nil)

end

function BuyConfirmLayer:rechargeCallbackFunction(state,prop)
    if prop.itemType == kItemTypeGold then
         if state == PAY.PAY_STATE_SUCCESS then
             PaySystem:bonus(prop.gold,true)
             -- EffectHelper.floatMessage("您获得了" .. self.prop.name .. " ( " .. self.prop.desc  ..")")
             
         else
             EffectHelper.floatMessage("充值失败,请联系客服人员")
         end
    end

    if self.callback then
        self.callback(state,prop)
    end
     self:dismissSelf()
end

function BuyConfirmLayer:payCallbackFunction(state,prop)
    if state == PAY.PAY_STATE_SUCCESS then

        if prop.itemType ~= kItemTypeGold then
            EffectHelper.floatMessage("您获得了" .. self.prop.name .. " ( " .. self.prop.desc  ..")")
            EquipSystem:buyItem(self.prop.itemId)
            EquipSystem:equipItem(self.prop.itemId)
            EquipSystem:save()
            audio.playEffect(R.SOUND_USE_GOLD,false)
        else
           
        end
        self:dismissSelf()
    elseif state == PAY.PAY_STATE_FAILED then
          
    end 

    if self.callback then
        self.callback(state,prop)
    end
  
end

function BuyConfirmLayer:onEnterTransitionFinish()
    
end


function BuyConfirmLayer:dismissSelf( ... )
    EffectHelper.WidgetBobbleOutEffect(self.panel,function()
         self:removeFromParentAndCleanup(true)
    end)
end

function BuyConfirmLayer:onExit()

end

return BuyConfirmLayer