--*******************************************
-- Desc: 购买弹出窗口
-- File: BuyConfirmLayer1.lua
-- Author: zhouhaifeng
-- Date: 2014-03-24 13:36:33
--*******************************************

local GameItems = import("app.datas.GameItems")
local NoMoneyConfirmLayer = import("app.layers.NoMoneyConfirmLayer")
local PackageLayer = import("app.layers.PackageLayer")
local BuyConfirmLayer1 = class("BuyConfirmLayer1",function()
	return display.newColorLayer(ccc4(0,0,0,180))
end)

--[[
	初始化
	确认购买界面
]]
function BuyConfirmLayer1:ctor()
    self.layer = UIModalLayer:create()
    self:addChild(self.layer);
end


function BuyConfirmLayer1:setItemIdToBuy(itemId,iconImage,callback)
  self.callback = callback

  local prop = GameItems[itemId]
  self.prop = prop

	 self.panel = ccs.image({
	 	 image = "ui/buy/ui_buy_bg.png",
	 	 x = display.cx, 
	 	 y = display.cy
	 })
 	 self.layer:addWidget(self.panel)

   --说明:
	  self.descLabel = ccs.label({
        text = prop.desc,
        fontSize = 16,
        x = 95,
        y = 10,
    })
    self.descLabel:setTextAreaSize(CCSizeMake(240,100))


    if prop.levelLimit then
       self.levelLimit = ccs.label({
          text = "需要:" .. TITLE_DATA[prop.levelLimit],
          fontSize = 16,
          x = -100, 
          y = -60
      })
      self.levelLimit:setTextAreaSize(CCSizeMake(150,40))
      self.panel:addChild(self.levelLimit)
    end

    local proptext = ""
    if self.prop.itemType == kItemTypeCars then
        proptext = "生命值+" .. self.prop.hp*100 .. "  最大速度:" .. self.prop.maxSpeed
    elseif self.prop.itemType == kItemTypeWeapon then
        proptext = "伤害:" .. self.prop.minHurt .. "-" .. self.prop.maxHurt .. "  弹夹容量:" .. self.prop.bullet
    elseif self.prop.itemType == kItemTypeClothes then
        proptext = "生命值+" .. self.prop.hp*100 .. "  伤害提升:" .. (self.prop.hurt - 1) * 100 .. "%"
     elseif self.prop.itemType == kItemTypeGold then
        proptext = "金币:" .. self.prop.gold
    end
    --属性
    self.propLabel = ccs.label({
        text = proptext,
        fontSize = 16,
        color = ccc3(96, 240, 90),
        x = 95,
        y = -40,
    })
    self.propLabel:setTextAreaSize(CCSizeMake(240,100))

    local price = prop.price
    if prop.buyType == 1 then
        price = price .. "元"
    elseif  prop.buyType == 0 then
        price = price .. ""
    else
        price = ""
    end

    self.itemIcon = ccs.image({
         image = iconImage,
         x = -200, 
         y = 25
     })
     self.itemIcon:setAnchorPoint(ccp(0,0.5))

	self.closeButton = ccs.button({
        normal  = "ui/buy/btn_close_n.png",
        pressed = "ui/buy/btn_close_h.png",
        x = -140,
        y = -100,
        listener = {[ccs.TouchEventType.ended] = function() 
            audio.playEffect(R.SOUND_BUTTON)
            self:removeFromParentAndCleanup(true)
            display.resume()
         end},
    })


    --购买
    self.buyButton = ccs.button({
        normal  = "ui/buy/btn_buy_n.png",
        pressed = "ui/buy/btn_buy_h.png",
        size = CCSize(150,45),
        scale9 = true,
        text = price,
        x = 130,
        y = -100,
        listener = {[ccs.TouchEventType.began] = function() 
              audio.playEffect(R.SOUND_BUTTON)

              --使用金币购买
              if self.prop.buyType == 0 then
                --金币支付
                  if PaySystem:buy(self.prop.itemId,true,function( ... ) self:payCallbackFunction( ... ) end) then

                  else 
                    EffectHelper.floatMessage("金币金额不足!")
                    self:removeFromParentAndCleanup(true)

                  end

              --使用人民币购买
              elseif self.prop.buyType == 1 then 
              
                 if self.prop.itemType == kItemTypeGold then
                     --充值金币
                      PaySystem:pay(self.prop.itemId,true,function( ... ) self:rechargeCallbackFunction( ... ) end)
                 else
                      --购买装备
                      local flag = EquipSystem:checkIsExist(self.prop.itemId)
                      if not flag then
                      --购买   
                          PaySystem:pay(self.prop.itemId, true, function( ... ) self:payCallbackFunction(...) end)
                      else
                      --已经存在
                          EquipSystem:equipItem(self.prop.itemId)
                          EffectHelper.floatMessage("您已经购买" .. self.prop.name)
                          self:dismissSelf()
                          audio.playEffect(R.SOUND_USE_ITEM,false)
                      end
                 end
             end
         display.resume()   
      end},
    })

    self.goldIcon = ccs.image({
         image = "ui/buy/ui_gold_icon.png",
         x = -45, 
         y = 0
     })
    self.buyButton:addChild(self.goldIcon)

    if prop.buyType == 1 then
        self.goldIcon:setVisible(false)
    end
    
    self.buyButton:setTitleFontSize(20)

    self.panel:addChild(self.propLabel)
    self.panel:addChild(self.descLabel)
    self.panel:addChild(self.itemIcon)
    self.panel:addChild(self.itemLabel)
    self.panel:addChild(self.priceLabel)
    self.panel:addChild(self.closeButton)
    self.panel:addChild(self.buyButton)

    EffectHelper.WidgetBobbleInEffect(self.panel,nil)
end


function BuyConfirmLayer1:rechargeCallbackFunction(state,prop)
    if prop.itemType == kItemTypeGold then
         if state == PAY.PAY_STATE_SUCCESS then
             PaySystem:bonus(prop.gold,true)
             -- EffectHelper.floatMessage("您获得了" .. self.prop.name .. " ( " .. self.prop.desc  ..")")
             
         else
             EffectHelper.floatMessage("充值失败,请联系客服人员")
         end
    end

    if self.callback then
        self.callback(state,prop)
    end
     self:dismissSelf()
end

function BuyConfirmLayer1:payCallbackFunction(state,prop)
    if state == PAY.PAY_STATE_SUCCESS then

        if prop.itemType ~= kItemTypeGold then
            EffectHelper.floatMessage("您获得了" .. self.prop.name .. " ( " .. self.prop.desc  ..")")
            EquipSystem:buyItem(self.prop.itemId)
            EquipSystem:equipItem(self.prop.itemId)
            EquipSystem:save()
            audio.playEffect(R.SOUND_USE_GOLD,false)
        else
           
        end
        self:dismissSelf()
    elseif state == PAY.PAY_STATE_FAILED then
          
    end 

    if self.callback then
        self.callback(state,prop)
    end
  
end

function BuyConfirmLayer1:onEnterTransitionFinish()
    
end


function BuyConfirmLayer1:dismissSelf( ... )
    EffectHelper.WidgetBobbleOutEffect(self.panel,function()
         self:removeFromParentAndCleanup(true)
    end)
end

function BuyConfirmLayer1:onExit()

end

return BuyConfirmLayer1