--*******************************************
-- Desc: 购买金币
-- File: GoldItemsLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-03-22 09:43:32
--*******************************************

local GameItems = import("app.datas.GameItems")
local BuyConfirmLayer = import("app.layers.BuyConfirmLayer")

local GoldItemsLayer = class("GoldItemsLayer",function()
	return display.newLayer()
end)

local contentWidth = display.width
local contentHeight = 250

local items = {
	[1] = {
		--武器
		{itemId = 9002, x = 120 , y = contentHeight - 120},
		{itemId = 9003, x = 260 , y = contentHeight - 120},
		{itemId = 9004, x = 400 , y = contentHeight - 120},
		{itemId = 9005, x = 540 , y = contentHeight - 120},
		{itemId = 9006, x = 680 , y = contentHeight - 120},
	}
}

--[[
	初始化
	params: 地图信息
]]
function GoldItemsLayer:ctor()
	self.layer = ccs.layer()
	self:addChild(self.layer)

	self.pageView = ccs.pageView({
        size = CCSizeMake(contentWidth,contentHeight),
        x = display.cx,
        y = display.cy - 10,
        listener = {[ccs.PageViewEventType.turning] = function(uiwidget)
     			
        end}
        })
	self.pageView:setAnchorPoint(ccp(0.5,0.5))

    for i=1,#items do

        local layout = ccs.panel({
            	size = self.pageView:getSize()
            })

       for k,v in pairs(items[i]) do
       	   local prop = GameItems[v.itemId] 
		   local button = ccs.button({ 
			    normal = "ui/level/ui_goldItem_" ..v.itemId ..".png",
			    pressed = "ui/level/ui_goldItem_" ..v.itemId ..".png",
			    x = v.x,
			    y = v.y,
			    listener = { [ccs.TouchEventType.ended] = function(uiwidget) self:buyItem(uiwidget)  end}
		    })
		    button:setTag(v.itemId)
      		layout:addChild(button)
       end
      
        self.pageView:addPage(layout)
    end

    self.layer:addWidget(self.pageView)
end

function GoldItemsLayer:buyItem(uiwidget) 
	-- CCLuaLog("buy" .. uiwidget:getTag())
	local buyConfirmLayer = BuyConfirmLayer.new()
	local itemId = uiwidget:getTag()
	buyConfirmLayer:setItemIdToBuy(itemId,"ui/level/ui_goldItem_" .. itemId ..".png")
	self:getParent():addChild(buyConfirmLayer)
end

function GoldItemsLayer:updateUI()

end

function GoldItemsLayer:onEnter()

end

function GoldItemsLayer:onExit()

end

return GoldItemsLayer