--*******************************************
-- Desc: 关卡弹出窗口
-- File: LevelConfirmLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-08-18 9:56:33
--*******************************************

local GameItems = import("app.datas.GameItems")
local PackageLayer = import(".PackageLayer")

local LevelConfirmLayer = class("LevelConfirmLayer",function()
	return display.newColorLayer(ccc4(0,0,0,192))
end)

--[[
	初始化
	确认购买界面
]]
function LevelConfirmLayer:ctor()
    self.layer = UIModalLayer:create()
    self:addChild(self.layer)
end


--[[
  设置UI弹出框
]]
function LevelConfirmLayer:setupUI(mapId,text,callback)

	 self.panel = ccs.image({
	 	 image = "ui/buy/ui_buy_bg.png",
	 	 x = display.cx, 
	 	 y = display.cy
	 })
 	 self.layer:addWidget(self.panel)

	 self.descLabel = ccs.label({
        text = text,
        fontSize = 18,
        x = 0,
        y = 0,
    })
    self.descLabel:setTextAreaSize(CCSizeMake(380,100))


	-- self.closeButton = ccs.button({
 --        normal  = "ui/buy/btn_close_n.png",
 --        pressed = "ui/buy/btn_close_h.png",
 --        x = -140,
 --        y = -90,
 --        listener = {[ccs.TouchEventType.ended] = function() 
 --            self:dismissSelf()
 --            -- CCLuaLog("remvoe")
 --         end},
 --    })

    --购买
    self.buyButton = ccs.button({
        normal  = "ui/buy/btn_buy_n.png",
        pressed = "ui/buy/btn_buy_h.png",
        size = CCSize(150,45),
        scale9 = true,
        text = "确定" ,
        x = 0,
        y = -90,
        listener = {[ccs.TouchEventType.began] = function() 
            self:dismissSelf()

            if mapId == 2 and LevelSystem:getCurrentLevel() < 7 then
              local packageLayer = PackageLayer:new()
              packageLayer:setupTitleUI(callback)
              self:getParent():addChild(packageLayer,1000)
            end
            -- if mapId == LevelSystem:getCurrentMap() + 1 then
            --     LevelSystem:setCurrentMap(mapId)
            --     callback()
            -- elseif mapId >= LevelSystem:getCurrentMap() + 1 then
            --     EffectHelper.floatTipInfo("你必须解锁上一个关卡才能解锁该关卡","info")  
            -- end 

        end},
    })
    self.buyButton:setTitleFontSize(20)

    self.panel:addChild(self.descLabel)
    self.panel:addChild(self.closeButton)
    self.panel:addChild(self.buyButton)

    EffectHelper.WidgetBobbleInEffect(self.panel,nil)
end

function LevelConfirmLayer:dismissSelf( ... )
    EffectHelper.WidgetBobbleOutEffect(self.panel,function()
         self:removeFromParentAndCleanup(true)
    end)
end

function LevelConfirmLayer:onExit()

end

return LevelConfirmLayer