--*******************************************
-- Desc: 金币不足，弹出窗口
-- File: NoMoneyConfirmLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-08-18 9:56:33
--*******************************************

local GameItems = import("app.datas.GameItems")

local NoMoneyConfirmLayer = class("NoMoneyConfirmLayer",function()
	return display.newColorLayer(ccc4(0,0,0,192))
end)

--[[
	初始化
	确认购买界面
]]
function NoMoneyConfirmLayer:ctor()
    self.layer = UIModalLayer:create()
    self:setupUI()
    self:addChild(self.layer)
end


--[[
  设置UI弹出框
]]
function NoMoneyConfirmLayer:setupUI()

	 self.panel = ccs.image({
	 	 image = "ui/buy/ui_buy_bg.png",
	 	 x = display.cx, 
	 	 y = display.cy
	 })
 	 self.layer:addWidget(self.panel)

	 self.descLabel = ccs.label({
        text = "您的金币不足，是否跳转到购买金币界面?",
        fontSize = 20,
        x = 0,
        y = 0,
    })
    self.descLabel:setTextAreaSize(CCSizeMake(380,100))


	self.closeButton = ccs.button({
        normal  = "ui/buy/btn_close_n.png",
        pressed = "ui/buy/btn_close_h.png",
        x = -140,
        y = -90,
        listener = {[ccs.TouchEventType.ended] = function() 
            self:dismissSelf()
            -- CCLuaLog("remvoe")
         end},
    })

    --购买
    self.buyButton = ccs.button({
        normal  = "ui/buy/btn_buy_n.png",
        pressed = "ui/buy/btn_buy_h.png",
        size = CCSize(150,45),
        scale9 = true,
        text = "购买金币" ,
        x = 130,
        y = -90,
        listener = {[ccs.TouchEventType.began] = function() 
            self:dismissSelf()
            MyApp:goToGold()
        end},
    })
    self.buyButton:setTitleFontSize(20)

    ccs.button({
        normal  = "ui/score/btn_sure_n.png",
        pressed = "ui/score/btn_sure_h.png",
        x = 130,
        y = -90,
        listener = {[ccs.TouchEventType.began] = function() 
            
      end},
    })

    self.panel:addChild(self.descLabel)
    self.panel:addChild(self.closeButton)
    self.panel:addChild(self.buyButton)

    EffectHelper.WidgetBobbleInEffect(self.panel,nil)
end

function NoMoneyConfirmLayer:dismissSelf( ... )
    EffectHelper.WidgetBobbleOutEffect(self.panel,function()
         self:removeFromParentAndCleanup(true)
    end)
end

function NoMoneyConfirmLayer:onExit()

end

return NoMoneyConfirmLayer