--*******************************************
-- Desc: 暂停层
-- File: PauseLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-03-09 15:44:01
--*******************************************

local TaskInfoCell = import("app.items.TaskInfoCell")
local PackageLayer = import("app.layers.PackageLayer")
local PauseLayer = class("PauseLayer",function()
	return display.newColorLayer(ccc4(0,0,0,192))
end)

--[[
	初始化
	params: 暂停界面
]]
function PauseLayer:ctor()
    g_IsPause = true

    local stepId = GameSystem:getGuideId()
    if  stepId == 10 or stepId == 11 or stepId == 12 then
        self.layer = ccs.layer()
    else 
        self.layer = UIModalLayer:create()
    end
    
    self:addChild(self.layer);

    self.pauseTitle = ccs.image({
        image = "ui/gameui/ui_pause_title.png",
        x = display.cx,
        y = display.cy + 130
    })
    self.layer:addWidget(self.pauseTitle)

    self.resumeButton = ccs.button({
        normal  = "ui/gameui/btn_continue_n.png",
        pressed = "ui/gameui/btn_continue_h.png",
        x = display.right - 120,
        y = display.bottom + 50,
        listener = {[ccs.TouchEventType.ended] = function() 
            audio.playEffect(R.SOUND_BUTTON)
            CCDirector:sharedDirector():resume()
            CCDirector:sharedDirector():startAnimation()
            self:removeFromParentAndCleanup(true)
             g_IsPause = false
         end},
    })

    self.supportButton = ccs.button({
      normal = "ui/buy/huoli_1.png",
      pressed = "ui/buy/huoli_1.png",
      x = display.cx,
      y = display.bottom + 60,
      listener = {[ccs.TouchEventType.began] = function()
         audio.playEffect(R.SOUND_BUTTON)
         local packageLayer = PackageLayer:new()
         packageLayer:setupSupportUI(callback,false)
         self:addChild(packageLayer,100)
      end},
    })


   self.exitButton = ccs.button({
        normal  = "ui/gameui/btn_pauseexit_n.png",
        pressed = "ui/gameui/btn_pauseexit_h.png",
        x = display.left + 120,
        y = display.bottom + 50,
        listener = {[ccs.TouchEventType.began] = function() 
            audio.playEffect(R.SOUND_BUTTON)
            CCDirector:sharedDirector():resume()
            CCDirector:sharedDirector():startAnimation()
            DataCenter:dispatchEvent({name = "GAME_FAILED"})
            self:removeSelf(true)
             g_IsPause = false
         end},
    })

    self.layer:addWidget(self.resumeButton)
    self.layer:addWidget(self.exitButton)
    self.layer:addWidget(self.supportButton)
    
    self.headIcon = display.newSprite("ui/playerinfo/title_" .. LevelSystem:getCurrentLevel() .. ".png", display.cx, display.cy + 40)
    self:addChild(self.headIcon)

    self.taskInfoCell = TaskInfoCell.new()
    self.taskInfoCell:setup({ 
        max = 3,
        cur = 1,
        on = "ui/playerinfo/ui_stars_1.png",
        off = "ui/playerinfo/ui_stars_0.png",
        x = display.cx - 120,
        y = display.cy - 30,   
    })
   self:addChild(self.taskInfoCell)
   TaskSystem:checkAll()
   self.taskInfoCell:setTaskInfo(TaskSystem._tasks)
    
   return self;
end

function PauseLayer:onEnter()
    g_IsPause = true
    CCDirector:sharedDirector():pause()
end

function PauseLayer:onExit()
    g_IsPause = false
    CCDirector:sharedDirector():resume()
end     

return PauseLayer