--*******************************************
-- Desc: 玩家信息类
-- File: PlayerInfoLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-03-21 21:15:23
--*******************************************


local StarRate = import("..utils.ui.StarRate")
local TaskInfoCell = import("app.items.TaskInfoCell")

local PlayerInfoLayer = class("PlayerInfoLayer",function()
    return display.newLayer("PlayerInfoLayer")
end) 


function PlayerInfoLayer:ctor()
	   self.isExpand = false

	  self.bg = display.newSprite("ui/playerinfo/ui_dk_0.png", display.cx, display.top-100)
	  self.bg:setAnchorPoint(ccp(0.5,0))
    self:addChild(self.bg)

    self.headIcon = display.newSprite("ui/playerinfo/title_" .. LevelSystem:getCurrentLevel() .. ".png", display.left+93, display.top-45)
    self:addChild(self.headIcon)

    self.titleBg = display.newSprite("ui/playerinfo/title_bg.png", display.left + 40, display.top-45)
    self:addChild(self.titleBg)

    self.distanceTitle = ui.newTTFLabel({
        text = "里程:",
        size = 22,
        color = ccc3(190, 250, 255),
        align = ui.TEXT_ALIGN_CENTER,
        x = display.cx,
        y = display.top - 62,
    })
    self.distanceTitle:setAnchorPoint(ccp(0.5,0.5))
    self:addChild(self.distanceTitle)

    self.killTitle =  ui.newTTFLabel({
        text = "击杀:",
        size = 22,
        color = ccc3(190, 250, 255),
        align = ui.TEXT_ALIGN_CENTER,  
        x = display.cx,
        y = display.top - 28,
    })
    self.killTitle:setAnchorPoint(ccp(0.5,0.5))
    self:addChild(self.killTitle)

    self.meterLabel = ui.newAtlasLabel({
        text = "0",
        start = '0',
        image = "ui/playerinfo/number_bar_record.png",
        w = 16,
        h = 18,
        align = ui.TEXT_ALIGN_LEFT, 
        x = display.cx + 40,
        y = display.top - 70,
    })
    self:addChild(self.meterLabel)

    self.killLabel = ui.newAtlasLabel({
        text = "0",
        start = '0',
        image = "ui/playerinfo/number_bar_record.png",
        w = 16,
        h = 18,
        align = ui.TEXT_ALIGN_LEFT,
        x = display.cx + 40,
        y = display.top - 35,
    })
    self:addChild(self.killLabel)
   
    self.goldLabel = ui.newAtlasLabel({
        text = "0",
        start = '0',
        image = "ui/playerinfo/number_bar_gold.png",
        w = 16,
        h = 27,
        align = ui.TEXT_ALIGN_LEFT,
        x = display.right - 185,
        y = display.top - 60,
    })

    self.goldIcon = display.newSprite("ui/playerinfo/ui_gold.png", display.right - 210, display.top - 45)
    self:addChild(self.goldIcon)

    self:addChild(self.goldLabel)

    -- create menu
   self.taskButton = ui.newImageMenuItem({
        image = "ui/playerinfo/ui_dkn_0.png",
        imageSelected = "ui/playerinfo/ui_dkn_0.png",
        x = display.cx,
        y = 10,
        listener = function()
      		self:setIsExpand()
        end,
    })

    -- create menu
   self.addMoneyButton = ui.newImageMenuItem({
        image = "ui/playerinfo/btn_add_n.png",
        imageSelected = "ui/playerinfo/btn_add_h.png",
        x = display.right - 40,
        y = display.top - 45,
        listener = function()
    		    MyApp:goToGold()
        end,
    })

   self.starRate = StarRate:new()
   self.starRate:setup({
        max = 3,
        cur = 1,
        on = "ui/playerinfo/ui_score_ystar.png",
        off = "ui/playerinfo/ui_score_wstar.png",
        x = display.left + 200,
        y = display.top-30,   
   })

   self:addChild(self.starRate)

   self.tipLabel = ui.newTTFLabel({
        text = "点击查看目标",
      	size = 18,
        color = ccc3(190, 250, 255),
      	align = ui.TEXT_ALIGN_CENTER,  
        x = display.left + 250,
        y = display.top - 65,
    })
    self.tipLabel:setAnchorPoint(ccp(0.5,0.5))
    self:addChild(self.tipLabel)
   
   self.moneyMenu = ui.newMenu({self.addMoneyButton})
   self:addChild(self.moneyMenu)


   self.expandMenu = ui.newMenu({self.taskButton})
   self.bg:addChild(self.expandMenu)

   self.taskInfoCell = TaskInfoCell.new()
   self.taskInfoCell:setup({ 
        max = 3,
        cur = 1,
        on = "ui/playerinfo/ui_stars_1.png",
        off = "ui/playerinfo/ui_stars_0.png",
        x = display.cx - 120,
        y = display.top - 100,   
   })

  self.taskInfoCell:setVisible(false)
  self:addChild(self.taskInfoCell)

  self:updateTaskInfo(false)
  
  self:setTouchEnabled(true)
  self:setTouchMode(kCCTouchesAllAtOnce)
  self:addTouchEventListener(function(event,touches)
      local pos = ccp(touches[1],touches[2])

      if event == "ended" then
          local rect = self.bg:getBoundingBox()
          -- CCLuaLog("(" .. rect.origin.x .. "," .. rect.origin.y .. "," .. rect.size.width .. "," .. rect.size.height .. ")")
          if rect:containsPoint(pos) then
              if pos.x > display.width - 220 then
                MyApp:goToGold()
              else 
                self:setIsExpand()
              end
          end
      end
     
    end ,true, -127,false)
end

function PlayerInfoLayer:setIsExpand()
  self.isExpand = not self.isExpand

	if self.isExpand then
  		local action = CCMoveTo:create(0.2, ccp(display.cx,display.top-200))
  		self.taskButton:setPositionY(5)
  		self.taskButton:setScaleY(-1)
  		self.bg:runAction(action)
      self:performWithDelay(function ()
          self.taskInfoCell:setVisible(true)
      end, 0.1)

	else
      local action = CCMoveTo:create(0.2, ccp(display.cx,display.top-100))
      self.taskButton:setPositionY(10)
      self.taskButton:setScaleY(1)
      self.bg:runAction(action)
     
      self.taskInfoCell:setVisible(false)
	end
end

function PlayerInfoLayer:hideGoldInfo()
      self.addMoneyButton:setVisible(false)
end

function PlayerInfoLayer:updateUI()
   self.meterLabel:setString(GameSystem._record.distance)
   self.goldLabel:setString(GameSystem._record.numberOfGlod)
   self.killLabel:setString(GameSystem._record.numberOfkillEnemy)
end

function PlayerInfoLayer:updateTaskInfo(flag)
    self.starRate:setRate(TaskSystem:getFinishTaskCount(),flag)
    self.taskInfoCell:setTaskInfo(TaskSystem._tasks)
end

function PlayerInfoLayer:eventHandler(event)
    if event.name == "GLOD_CHANGED_EVENT" then
        self:updateUI()
    elseif event.name == "TITLE_CHANGED_EVENT" then
          self:updateTaskInfo(false)
          local pSpriteFrame = CCSpriteFrame:create("ui/playerinfo/title_" .. LevelSystem:getCurrentLevel() .. ".png", CCRectMake(0, 0, 145, 74))
          self.headIcon:setDisplayFrame(pSpriteFrame)
    
    end
end

function PlayerInfoLayer:onEnter()
   self._eventHandler = function(event,args)
       self:eventHandler(event,args)
   end

   DataCenter:addEventListener("GLOD_CHANGED_EVENT",self._eventHandler)
   DataCenter:addEventListener("TITLE_CHANGED_EVENT",self._eventHandler)

	 self:updateUI()
end

function PlayerInfoLayer:onExit()
    DataCenter:removeEventListener("GLOD_CHANGED_EVENT",self._eventHandler)
    DataCenter:removeEventListener("TITLE_CHANGED_EVENT",self._eventHandler)
end

return PlayerInfoLayer
