--*******************************************
-- Desc: 记录展示层
-- File: RecordsLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-03-22 09:43:32
--*******************************************

local RecordsLayer = class("RecordsLayer",function()
	return display.newLayer()
end)

local contentWidth = 720
local contentHeight = 250

local items = {
	[1] = {
		{name = "总里程", type=1, data = "distance", suffix = "m"},
		{name = "杀死僵尸数",type=1, data = "numberOfkillEnemy" ,suffix = "只"},
		{name = "消灭普通BOSS", type=1, data = "numberOfkillBoss" , suffix = "只"},
		{name = "消灭高级BOSS",type=1, data = "numberOfkillAdvBoss" , suffix = "只"},
		{name = "消灭超级BOSS",type=1, data = "numberOfkillSuperBoss" , suffix = "只"},
		{name = "破坏汽车", type=1 , data = "numberOfhitCars", suffix = "辆"},
		{name = "最快速度", type=1 , data = "maxNumberOfSpeed", suffix = "码"},
		
	},
	[2] = {
		{name = "跳跃次数", type=1 , data = "numberOfFly" ,suffix = "次"},
		{name = "死亡次数", type=1, data = "numberOfDeads",suffix = "次"},
		{name = "最大连击数",type=1, data = "maxNumberOfCombs",suffix = "次"},
		{name = "最喜欢武器", type=3, data = kItemTypeWeapon ,suffix = ""},
		{name = "最喜欢摩托车", type=3, data = kItemTypeCars ,suffix = ""},
		{name = "消耗金币", type=1, data = "useOfGlod",suffix = "枚"},
		{name = "最长时间", type=2, data = "maxTimeOfForeverMode",suffix = ""},
	}
}

--[[
	初始化
	params: 地图信息
]]
function RecordsLayer:ctor()
	self.layer = ccs.layer()
	self:addChild(self.layer)

	self.bgView = display.newScale9Sprite("ui/common/ui_common_bg.png", display.cx, display.cy, CCSizeMake(560, 320))

    for i=1,#items do
       for k,v in pairs(items[i]) do
		   local label = ui.newTTFLabel({ 
		      	size = 18,
		      	align = ui.TEXT_ALIGN_RIGHT,  
		        x = 160+240*(i-1),
		        y = 300 - 36 * k,
			    text = v.name .. ":",
		    })
      		self.bgView:addChild(label)

      		--数字类型，从GameSystem中获取
      		if v.type == 1 then
      			local value = GameSystem:getTotal(v.data) or 0
	      		local text = ui.newTTFLabel({ 
			      	size = 18,
			      	align = ui.TEXT_ALIGN_LEFT,  
			        x = 165+240*(i-1),
			        y = 300 - 36 * k,
				    text = value .. v.suffix
			    })
	      		self.bgView:addChild(text)

	      	--时间类型，从GameSystem中获取	
      		elseif v.type == 2 then
      			local time = GameSystem:getTotal(v.data) or 0
      			local text = ui.newTTFLabel({ 
			      	size = 18,
			      	align = ui.TEXT_ALIGN_LEFT,  
			        x = 165+240*(i-1),
			        y = 300 - 36 * k,
				    text = cf.timeConvert(time) .. v.suffix
			    })
	      		self.bgView:addChild(text)	
      			
      		--最喜欢的道具，从EquipSystem中获取
      		elseif v.type == 3 then
      			local name = "无"
      			local prop = EquipSystem:getFavouriteItem(v.data)
     
      			if prop then
      				name = prop.name
      			end

      			local text = ui.newTTFLabel({
			      	size = 18,
			      	align = ui.TEXT_ALIGN_LEFT,  
			        x = 165+240*(i-1),
			        y = 300 - 36 * k,
				    text = name .. v.suffix
			    })
	      		self.bgView:addChild(text)	
      		end
       end
    end

    self.layer:addChild(self.bgView)
end


function RecordsLayer:updateUI()
    -- body
end

function RecordsLayer:onEnter()

end

function RecordsLayer:onExit()

end

return RecordsLayer