--*******************************************
-- Desc: 任务信息
-- File: TaskInfoLayer.lua
-- Author: zhouhaifeng
-- Date: 2014-03-27 15:17:01
--*******************************************
local TaskInfoCell = import("..items.TaskInfoCell")
local TaskInfoLayer = class("TaskInfoLayer",function()
	return display.newColorLayer(ccc4(0,0,0,180))
end)

--[[
	初始化
]]
function TaskInfoLayer:ctor()
    self.layer = UIModalLayer:create()
    self:addChild(self.layer);

    self:setAwardInfo()
end

function TaskInfoLayer:setAwardInfo()
	local level = LevelSystem:getCurrentLevelInfo()

	 self.panel = ccs.image({
	 	 image = "ui/buy/ui_buy_bg.png",
	 	 x = display.cx, 
	 	 y = display.cy
	 })
 	 self.layer:addWidget(self.panel)

 	self.itemLabel = ccs.image({
        image = "ui/score/ui_levelup_title.png",
        x = -10,
        y = 80,
    })

    self.arrowIcon = ccs.image({
        image = "ui/score/ui_arrow_icon.png",
        x = -10,
        y = -15,
    })

	self.currentLevel = ccs.image({
        image = "ui/playerinfo/title_" .. LevelSystem:getCurrentLevel() .. ".png",
        fontSize = 20,
        x = -100,
        y = -10,
    })

    self.nextLevel = ccs.image({
        image = "ui/playerinfo/title_" .. LevelSystem:getCurrentLevel() + 1 .. ".png",
        fontSize = 20,
        x = 100,
        y = -10,
    })

    self.sureButton = ccs.button({
        normal  = "ui/score/btn_sure_n.png",
        pressed = "ui/score/btn_sure_h.png",
        x = -10,
        y = -95,
        listener = {[ccs.TouchEventType.began] = function() 
            PaySystem:bonus(level.awardsMoney, false)
            LevelSystem:finishLevel(LevelSystem:getCurrentLevel())
            self:dismissSelf()
         end},
    })

    self.panel:addChild(self.currentLevel)
    self.panel:addChild(self.nextLevel)
    self.panel:addChild(self.arrowIcon)
    self.panel:addChild(self.itemLabel)
    self.panel:addChild(self.sureButton)
end

function TaskInfoLayer:setCallBack(callback)
    self.callback = callback
end

function TaskInfoLayer:onEnterTransitionFinish()
    EffectHelper.WidgetBobbleInEffect(self.panel,function( ... )

    end)
end


function TaskInfoLayer:dismissSelf( ... )

    EffectHelper.WidgetBobbleOutEffect(self.panel,function()
         self.callback()
         self:removeFromParentAndCleanup(true)
    end)
end


function TaskInfoLayer:onExit()

end

return TaskInfoLayer