--*******************************************
-- Desc: 商店类
-- File: GoldScene.lua
-- Author: zhouhaifeng
-- Date: 2014-03-21 20:48:59
--*******************************************

local PlayerInfoLayer = import("..layers.PlayerInfoLayer")
local GoldItemsLayer = import("..layers.GoldItemsLayer")

local GoldScene = class("GoldScene", function()
    return display.newScene("GoldScene")
end)

function GoldScene:ctor()
	self.bg = display.newSprite("ui/start/ui_bg.jpg", display.cx, display.cy)
	display.setIsBackgroundImage(self.bg)
    self:addChild(self.bg)

    self.goldItemsLayer = GoldItemsLayer.new()
	self:addChild(self.goldItemsLayer)

	self.playerInfoLayer = PlayerInfoLayer.new()
	self.playerInfoLayer:setTouchEnabled(false)
	self.playerInfoLayer:hideGoldInfo()
	self:addChild(self.playerInfoLayer)

 	self.backButton = ui.newImageMenuItem({
	    image = "ui/common/btn_back_n.png",
	    imageSelected = "ui/common/btn_back_h.png",
	    x = display.left + 120,
	    y = display.bottom + 40,
	    listener = function()
	    audio.playEffect(R.SOUND_BUTTON)
			MyApp:popGold()
	    end,
    })

   self.startMenu = ui.newMenu({self.backButton})
   self:addChild(self.startMenu)

end

function GoldScene:onEnter()
	
end

function GoldScene:onExit()
	
end

return GoldScene
