--*********************************************
-- Desc: 货币系统
-- File: PaySystem.lua
-- Author: zhouhaifeng
-- Date: 2014-4-2 11:46:07
--*********************************************


require("app.utils.sdk.paysdk.CMGameSDK")

PAY = {
	PAY_STATE_SUCCESS = 0,
	PAY_STATE_FAILED = 1,
	PAY_STATE_CANCEL= 2,
	PAY_STATE_UNKNOW = 3,
}

local GameItems = import("app.datas.GameItems")
local Pay = import("app.utils.GameData")
local PaySystem = {}
local KEY = "Pay"

function PaySystem:init()
	self._pay = {}
	self:save()
end

--[[
	真实人民币购买
]]
function PaySystem:pay(itemId,showTip,callback,newprice)
	--TODO
	--sdk pay

	local prop = EquipSystem:getEquipProp(itemId)
	local price = newprice or prop.price
	--计费预留接口
	if device.platform == "android" then
		CMGameSDK.doBilling(prop.billingIndex,true,true,function(result)
	         if result == "success" then
	         	callback(PAY.PAY_STATE_SUCCESS,prop)
	         elseif result == "failed" then
	         	callback(PAY.PAY_STATE_FAILED,prop)
	         elseif result == "cancel" then
	         	callback(PAY.PAY_STATE_CANCEL,prop)
	         end
	    end)
	else
		callback(PAY.PAY_STATE_SUCCESS,prop)
	end

	return true
end

--[[
	虚拟币购买道具
]]
function PaySystem:buy(itemId,showTip,callback,newprice)

	local prop = EquipSystem:getEquipProp(itemId)
	local price = newprice or prop.price
	-- CCLuaLog("buy " .. itemId .. " use:" .. price)
	
	local flag = self:use(price,true)
	if flag then
		callback(PAY.PAY_STATE_SUCCESS,prop)
	else
		callback(PAY.PAY_STATE_FAILED,prop)
	end
	GameSystem:save()
	return flag
end

--[[
	金币消耗，功能
]]
function PaySystem:use(number,showTip)
	
	if GameSystem._record.numberOfGlod >= number then
		GameSystem._record.numberOfGlod = GameSystem._record.numberOfGlod - number
		GameSystem._record.useOfGlod = GameSystem._record.useOfGlod + number
		GameSystem:save()
		
		DataCenter:dispatchEvent({name = "GLOD_CHANGED_EVENT"})
		EffectHelper.floatTipInfo("消耗".. number .."金币","info")
		GameSystem:save()
	else
		if showTip then
			-- EffectHelper.floatTipInfo("您的金币不足(可以点击右上角购买金币)", "warn")
		end
		return false
	end
	return true
end


--[[
	奖励游戏币
]]
function PaySystem:bonus(number,showTip)
	GameSystem._record.numberOfGlod = GameSystem._record.numberOfGlod + number
	if showTip then
		EffectHelper.floatTipInfo("获得".. number .."金币","info")
		audio.playEffect(R.SOUND_USE_GOLD,false)
	end
	DataCenter:dispatchEvent({name = "GLOD_CHANGED_EVENT"})
	GameSystem:save()
end


--[[
	加载成就信息
]]
function PaySystem:load()
	Pay.init(KEY,function(event)
			if event.name == "load" then
				if event.errorCode ~= nil then
					if event.errorCode == ERROR_STATE_FILE_NOT_FOUND then
						self:init()
					end
				else
					if event.values ~= nil and type(event.values) == "table" then
						self._pay = clone(event.values)
						-- CCLuaLog("load success")
					else
						self:init()
					end
				end
			elseif event.name == "save" then
				-- CCLuaLog("save success!")
				return event.values
			end
	end,"pay.dat",KEY)

	Pay.load(KEY)
end

--[[
	保存成就
]]
function PaySystem:save()
	Pay.save(KEY,self._pay)
end


return PaySystem
